<html>
<head>
<title>OGRE: OgreStaticGeometry.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreStaticGeometry.h</h1><a href="OgreStaticGeometry_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __StaticGeometry_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __StaticGeometry_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00113"></a><a class="code" href="classOgre_1_1StaticGeometry.html">00113</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115     <span class="keyword">public</span>:
<a name="l00128"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html">00128</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html" title="Struct holding geometry optimised per SubMesh / lod level, ready for copying to instances...">OptimisedSubMeshGeometry</a>
<a name="l00129"></a>00129         {
<a name="l00130"></a>00130         <span class="keyword">public</span>:
<a name="l00131"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html#d74c3d8bc57c3902ad3f1be62fc552fd">00131</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html" title="Struct holding geometry optimised per SubMesh / lod level, ready for copying to instances...">OptimisedSubMeshGeometry</a>() :vertexData(0), indexData(0) {}
<a name="l00132"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html#37aaec0b804ce2f86a6e3646524a517f">00132</a>             ~<a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html" title="Struct holding geometry optimised per SubMesh / lod level, ready for copying to instances...">OptimisedSubMeshGeometry</a>() 
<a name="l00133"></a>00133             {
<a name="l00134"></a>00134                 <span class="keyword">delete</span> vertexData;
<a name="l00135"></a>00135                 <span class="keyword">delete</span> indexData;
<a name="l00136"></a>00136             }
<a name="l00137"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html#8c758564b40d121b4ec99c1e31dc04b3">00137</a>             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *vertexData;
<a name="l00138"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1OptimisedSubMeshGeometry.html#fee0d52be974cc287c49c1988ca570aa">00138</a>             <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> *indexData;
<a name="l00139"></a>00139         };
<a name="l00140"></a><a class="code" href="classOgre_1_1StaticGeometry.html#2cf30b583c41eb0174b4cbeb5db4e75a">00140</a>         <span class="keyword">typedef</span> std::list&lt;OptimisedSubMeshGeometry*&gt; OptimisedSubMeshGeometryList;
<a name="l00143"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html">00143</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html" title="Saved link between SubMesh at a LOD and vertex/index data May point to original or...">SubMeshLodGeometryLink</a>
<a name="l00144"></a>00144         {
<a name="l00145"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html#156a3afb790d7e13663cbd7ee45faac6">00145</a>             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData;
<a name="l00146"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html#c387382c92a7e1c59757e86e289e589f">00146</a>             <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* indexData;
<a name="l00147"></a>00147         };
<a name="l00148"></a><a class="code" href="classOgre_1_1StaticGeometry.html#9a3a337c0d120c4c3bf65850c25b103a">00148</a>         <span class="keyword">typedef</span> std::vector&lt;SubMeshLodGeometryLink&gt; SubMeshLodGeometryLinkList;
<a name="l00149"></a><a class="code" href="classOgre_1_1StaticGeometry.html#80c5f8105181b3e77468a87e5351825b">00149</a>         <span class="keyword">typedef</span> std::map&lt;SubMesh*, SubMeshLodGeometryLinkList*&gt; SubMeshGeometryLookup;
<a name="l00151"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html">00151</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html" title="Structure recording a queued submesh for the build.">QueuedSubMesh</a>
<a name="l00152"></a>00152         {
<a name="l00153"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#6a73cc0fc7d1205b8bddcddf8b5a7ec8">00153</a>             <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* submesh;
<a name="l00155"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#8bcb418431638051229f226904813245">00155</a>             SubMeshLodGeometryLinkList* geometryLodList;
<a name="l00156"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#fd583dc14d063346a5e58601a23cf0de">00156</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> materialName;
<a name="l00157"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#74a6a5fd49b1797615439b118cd5395e">00157</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> position;
<a name="l00158"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#641f30e3a07966271a727f113a1ae529">00158</a>             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> orientation;
<a name="l00159"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#c8f3fa1934b2e7239b4ea3fd6c0d2fb4">00159</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> scale;
<a name="l00161"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html#cfa0525ff64b7603a33fb7c57edbee57">00161</a>             <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> worldBounds;
<a name="l00162"></a>00162         };
<a name="l00163"></a><a class="code" href="classOgre_1_1StaticGeometry.html#170301c4c8d1c95dcb322ed825007595">00163</a>         <span class="keyword">typedef</span> std::vector&lt;QueuedSubMesh*&gt; QueuedSubMeshList;
<a name="l00165"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html">00165</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html" title="Structure recording a queued geometry for low level builds.">QueuedGeometry</a>
<a name="l00166"></a>00166         {
<a name="l00167"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html#c16c7a7bff4440f883c31c85f7bf7bd2">00167</a>             <a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html" title="Saved link between SubMesh at a LOD and vertex/index data May point to original or...">SubMeshLodGeometryLink</a>* geometry;
<a name="l00168"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html#6ea20308c6c2919a63c24d1273f21f03">00168</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> position;
<a name="l00169"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html#1a9af1b18aec22c5a9f39d487c859a0b">00169</a>             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> orientation;
<a name="l00170"></a><a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html#f13765fe72f89bd33db5feec0beec29b">00170</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> scale;
<a name="l00171"></a>00171         };
<a name="l00172"></a><a class="code" href="classOgre_1_1StaticGeometry.html#0d1eafab98ba3f36b7ac8d39868bd158">00172</a>         <span class="keyword">typedef</span> std::vector&lt;QueuedGeometry*&gt; QueuedGeometryList;
<a name="l00173"></a>00173         
<a name="l00174"></a>00174         <span class="comment">// forward declarations</span>
<a name="l00175"></a>00175         <span class="keyword">class </span><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>;
<a name="l00176"></a>00176         <span class="keyword">class </span><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>;
<a name="l00177"></a>00177         <span class="keyword">class </span><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>;
<a name="l00178"></a>00178 
<a name="l00183"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html">00183</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex...">GeometryBucket</a> :  <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00184"></a>00184         {
<a name="l00185"></a>00185         <span class="keyword">protected</span>:
<a name="l00187"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#144fa0aa5fa30964e9aa940585b18437">00187</a>             QueuedGeometryList mQueuedGeometry;
<a name="l00189"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f00853755640ffb1c91b1b19d47c7199">00189</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>* mParent;
<a name="l00191"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#7e24b668910d95c23cb3059268b97c19">00191</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mFormatString;
<a name="l00194"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#0ab5e4a8cfbdfc6371fc5478ad73ca61">00194</a>             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* mVertexData;
<a name="l00197"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#910dedbe42c47e7f58d4dba3e0323bb9">00197</a>             <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* mIndexData;
<a name="l00199"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#5be88f404a20fd8dd1a0a847254c4500">00199</a>             <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> mIndexType;
<a name="l00201"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f9794e31362b5c99a235ef0a277b475d">00201</a>             <span class="keywordtype">size_t</span> mMaxVertexIndex;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203             <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00204"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#bac912a5e1f232434ef16508c6ed0253">00204</a>             <span class="keywordtype">void</span> copyIndexes(<span class="keyword">const</span> T* src, T* dst, <span class="keywordtype">size_t</span> count, <span class="keywordtype">size_t</span> indexOffset)
<a name="l00205"></a>00205             {
<a name="l00206"></a>00206                 <span class="keywordflow">if</span> (indexOffset == 0)
<a name="l00207"></a>00207                 {
<a name="l00208"></a>00208                     memcpy(dst, src, <span class="keyword">sizeof</span>(T) * count);
<a name="l00209"></a>00209                 }
<a name="l00210"></a>00210                 <span class="keywordflow">else</span>
<a name="l00211"></a>00211                 {
<a name="l00212"></a>00212                     <span class="keywordflow">while</span>(count--)
<a name="l00213"></a>00213                     {
<a name="l00214"></a>00214                         *dst++ = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(*src++ + indexOffset);
<a name="l00215"></a>00215                     }
<a name="l00216"></a>00216                 }
<a name="l00217"></a>00217             }
<a name="l00218"></a>00218         <span class="keyword">public</span>:
<a name="l00219"></a>00219             <a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex...">GeometryBucket</a>(<a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; formatString, 
<a name="l00220"></a>00220                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vData, <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* iData);
<a name="l00221"></a>00221             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex...">GeometryBucket</a>();
<a name="l00222"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#08c9ddb2a363d7d90878d69c6776faa7">00222</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>* getParent(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mParent; }
<a name="l00224"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#c743cdd75e571ab5cdbdb827593fc600">00224</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* getVertexData(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexData; }
<a name="l00226"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#2adc91a576fd750188ea3a8d558f093f">00226</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* getIndexData(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexData; }
<a name="l00228"></a>00228             <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00229"></a>00229             <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00230"></a>00230             <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00231"></a>00231             <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00232"></a>00232             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getWorldOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00233"></a>00233             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getWorldPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00234"></a>00234             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00235"></a>00235             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00236"></a>00236             <span class="keywordtype">bool</span> getCastsShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00237"></a>00237             
<a name="l00241"></a>00241             <span class="keywordtype">bool</span> assign(<a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html" title="Structure recording a queued geometry for low level builds.">QueuedGeometry</a>* qsm);
<a name="l00243"></a>00243             <span class="keywordtype">void</span> build(<span class="keywordtype">bool</span> stencilShadows);
<a name="l00245"></a>00245             <span class="keywordtype">void</span> dump(std::ofstream&amp; of) <span class="keyword">const</span>;
<a name="l00246"></a>00246         };
<a name="l00249"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">00249</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>
<a name="l00250"></a>00250         {
<a name="l00251"></a>00251         <span class="keyword">public</span>:
<a name="l00253"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#59961706795c7ad082210c65748d0c83">00253</a>             <span class="keyword">typedef</span> std::vector&lt;GeometryBucket*&gt; GeometryBucketList;
<a name="l00254"></a>00254         <span class="keyword">protected</span>:
<a name="l00256"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#7c1560c621c28c3dedde95a6478f603f">00256</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>* mParent;
<a name="l00258"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#d9732afaff3edb7e770816e80843e772">00258</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mMaterialName;
<a name="l00260"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#98238b3d99e1b247a587ae1fba6ab733">00260</a>             <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> mMaterial;
<a name="l00262"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#3622d108622b55d5da61c1db57f9b0e8">00262</a>             <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* mTechnique;
<a name="l00263"></a>00263 
<a name="l00265"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#98201e87d7d58a688a522c76864a19fa">00265</a>             GeometryBucketList mGeometryBucketList;
<a name="l00266"></a>00266             <span class="comment">// index to current Geometry Buckets for a given geometry format</span>
<a name="l00267"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#4a21218714f6d750336af9fad86da823">00267</a>             <span class="keyword">typedef</span> std::map&lt;String, GeometryBucket*&gt; CurrentGeometryMap;
<a name="l00268"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#912c4811ed0139c062c652379bb1a934">00268</a>             CurrentGeometryMap mCurrentGeometryMap;
<a name="l00270"></a>00270             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getGeometryFormatString(<a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html" title="Saved link between SubMesh at a LOD and vertex/index data May point to original or...">SubMeshLodGeometryLink</a>* geom);
<a name="l00271"></a>00271             
<a name="l00272"></a>00272         <span class="keyword">public</span>:
<a name="l00273"></a>00273             <a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>(<a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName);
<a name="l00274"></a>00274             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html" title="A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly...">MaterialBucket</a>();
<a name="l00275"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#b454a749c2ba7bae4002c70ed5afa626">00275</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>* getParent(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mParent; }
<a name="l00277"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#5d5aba36b489789f297a57087f223d85">00277</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterialName; }
<a name="l00279"></a>00279             <span class="keywordtype">void</span> assign(<a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html" title="Structure recording a queued geometry for low level builds.">QueuedGeometry</a>* qsm);
<a name="l00281"></a>00281             <span class="keywordtype">void</span> build(<span class="keywordtype">bool</span> stencilShadows);
<a name="l00283"></a>00283             <span class="keywordtype">void</span> addRenderables(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> group, 
<a name="l00284"></a>00284                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> camSquaredDist);
<a name="l00286"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#a338a96b9145a0c01e33da7e4728111c">00286</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterial; }
<a name="l00288"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#b2f7c7785a86b2bf05998b96b73c5952">00288</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;GeometryBucketList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">GeometryIterator</a>;
<a name="l00290"></a>00290             <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">GeometryIterator</a> getGeometryIterator(<span class="keywordtype">void</span>);
<a name="l00292"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html#a64dfa9bd9617249def12e684dde9caa">00292</a>             <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getCurrentTechnique(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTechnique; }
<a name="l00294"></a>00294             <span class="keywordtype">void</span> dump(std::ofstream&amp; of) <span class="keyword">const</span>;
<a name="l00295"></a>00295         };
<a name="l00301"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html">00301</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303         <span class="keyword">public</span>:
<a name="l00305"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#c66c126a9e8cace5c45cf200d17221fe">00305</a>             <span class="keyword">typedef</span> std::map&lt;String, MaterialBucket*&gt; MaterialBucketMap;
<a name="l00306"></a>00306         <span class="keyword">protected</span>:
<a name="l00308"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#03f9b9248ff57644c60dc0b4682d293c">00308</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* mParent;
<a name="l00310"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#67e09710f5418970c58ed89a027a488f">00310</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mLod;
<a name="l00312"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#b32f6759b0952234ea7e1adf10ef4dcd">00312</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mSquaredDistance;
<a name="l00314"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#f65f1afc96fc9ed08484f19e9ae3f609">00314</a>             MaterialBucketMap mMaterialBucketMap;
<a name="l00316"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#01726fd1d7aae9f58c14207a9a0d827c">00316</a>             QueuedGeometryList mQueuedGeometryList;
<a name="l00317"></a>00317         <span class="keyword">public</span>:
<a name="l00318"></a>00318             <a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>(<a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> lod, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lodDist);
<a name="l00319"></a>00319             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html" title="A LODBucket is a collection of smaller buckets with the same LOD.">LODBucket</a>();
<a name="l00320"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#5d7eea966adea0bb4f256150e124931b">00320</a>             <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* getParent(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mParent; }
<a name="l00322"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#ba243a0af2f306b9181b573dcb3967a1">00322</a>             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getLod(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLod; }
<a name="l00324"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#bf5da8fc3e2ac676a1a447751f9bb740">00324</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredDistance(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSquaredDistance; }
<a name="l00326"></a>00326             <span class="keywordtype">void</span> assign(<a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html" title="Structure recording a queued submesh for the build.">QueuedSubMesh</a>* qsm, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> atLod);
<a name="l00328"></a>00328             <span class="keywordtype">void</span> build(<span class="keywordtype">bool</span> stencilShadows);
<a name="l00330"></a>00330             <span class="keywordtype">void</span> addRenderables(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> group, 
<a name="l00331"></a>00331                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> camSquaredDistance);
<a name="l00333"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1LODBucket.html#6240319f801ee4f58cacb9ceccd9496b">00333</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;MaterialBucketMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MaterialIterator</a>;
<a name="l00335"></a>00335             <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MaterialIterator</a> getMaterialIterator(<span class="keywordtype">void</span>);
<a name="l00337"></a>00337             <span class="keywordtype">void</span> dump(std::ofstream&amp; of) <span class="keyword">const</span>;
<a name="l00338"></a>00338             
<a name="l00339"></a>00339         };
<a name="l00348"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html">00348</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>
<a name="l00349"></a>00349         {
<a name="l00350"></a>00350         <span class="keyword">public</span>:
<a name="l00352"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#5249ca40ad17fae7ce97c26dd3bf3f00">00352</a>             <span class="keyword">typedef</span> std::vector&lt;LODBucket*&gt; LODBucketList;
<a name="l00353"></a>00353         <span class="keyword">protected</span>:
<a name="l00355"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html">00355</a>             <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html" title="Nested class to allow region shadows.">RegionShadowRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>
<a name="l00356"></a>00356             {
<a name="l00357"></a>00357             <span class="keyword">protected</span>:
<a name="l00358"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html#bc4922377a17078918ecabb9d19d0b4e">00358</a>                 <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* mParent;
<a name="l00359"></a>00359                 <span class="comment">// Shared link to position buffer</span>
<a name="l00360"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html#860b2d9cfc31df78c98bd28a65205b3e">00360</a>                 <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> mPositionBuffer;
<a name="l00361"></a>00361                 <span class="comment">// Shared link to w-coord buffer (optional)</span>
<a name="l00362"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html#5c056117fc5bbacbde2b7902257f0dcd">00362</a>                 <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> mWBuffer;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364             <span class="keyword">public</span>:
<a name="l00365"></a>00365                 <a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html" title="Nested class to allow region shadows.">RegionShadowRenderable</a>(<a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* parent, 
<a name="l00366"></a>00366                     <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, 
<a name="l00367"></a>00367                     <span class="keywordtype">bool</span> createSeparateLightCap, <span class="keywordtype">bool</span> isLightCap = <span class="keyword">false</span>);
<a name="l00368"></a>00368                 ~<a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html" title="Nested class to allow region shadows.">RegionShadowRenderable</a>();
<a name="l00370"></a>00370                 <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00372"></a>00372                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getWorldOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00374"></a>00374                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getWorldPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00375"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html#bb67440aa1d39568eceea13996d6b589">00375</a>                 <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> getPositionBuffer(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mPositionBuffer; }
<a name="l00376"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region_1_1RegionShadowRenderable.html#2ded0a507c7a82efa83b39d83da10e24">00376</a>                 <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> getWBuffer(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mWBuffer; }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378             };
<a name="l00380"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#5e91f7c10b8ea77e37273e9c0027016c">00380</a>             <a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>* mParent;
<a name="l00382"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#578512e4c8934f96efe75a5ea9a50cca">00382</a>             <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* mSceneMgr;
<a name="l00384"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#50e4fe72baa5e986acfe6b9f05b7c917">00384</a>             <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* mNode;
<a name="l00386"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#97f9f72fedff666f236c3bd3de68c163">00386</a>             QueuedSubMeshList mQueuedSubMeshes;
<a name="l00388"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#92c38ef30f949ccbee8a4b9c2199d598">00388</a>             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mRegionID;
<a name="l00390"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#567eff7b26df31dcf340aa010e4da327">00390</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mCentre;
<a name="l00392"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#d188f66563423273822623ffc0d51d3e">00392</a>             std::vector&lt;Real&gt; mLodSquaredDistances;
<a name="l00394"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#0bce41bf7680554b27b1450c2d5f6594">00394</a>             <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> mAABB;
<a name="l00396"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#fbfd1ae5118fcd72eaa9d633d1f5b396">00396</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBoundingRadius;
<a name="l00398"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#172e92a82c5019f15537082198cc0c1a">00398</a>             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> mCurrentLod;
<a name="l00400"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#dfe74e2576441cd26f6d911fca61ff7e">00400</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mCamDistanceSquared;
<a name="l00402"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#3bb086965df6abd3fc1725544130b317">00402</a>             LODBucketList mLodBucketList;
<a name="l00404"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#b16003fcacb17f240dcdaeac71d506b0">00404</a>             <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a> mLightList;
<a name="l00406"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#5737854de590e59b6099aa0c5f3d5f38">00406</a>             <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a> mLightListUpdated;
<a name="l00408"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#fc95c6abf02f600a6e1a00ee70174ef0">00408</a>             <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* mEdgeList;
<a name="l00410"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#991eab2b9b8ae190979a4ee5cb92ab95">00410</a>             ShadowRenderableList mShadowRenderables;
<a name="l00412"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#2a4e65b10c6f3776c201a17a72015fa5">00412</a>             <span class="keywordtype">bool</span> mVertexProgramInUse;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416         <span class="keyword">public</span>:
<a name="l00417"></a>00417             <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>(<a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* mgr, 
<a name="l00418"></a>00418                 <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> regionID, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; centre);
<a name="l00419"></a>00419             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>();
<a name="l00420"></a>00420             <span class="comment">// more fields can be added in subclasses</span>
<a name="l00421"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#612b5be632834714195d8d0339fa8fc1">00421</a>             <a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>* getParent(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent;}
<a name="l00423"></a>00423             <span class="keywordtype">void</span> assign(<a class="code" href="structOgre_1_1StaticGeometry_1_1QueuedSubMesh.html" title="Structure recording a queued submesh for the build.">QueuedSubMesh</a>* qmesh);
<a name="l00425"></a>00425             <span class="keywordtype">void</span> build(<span class="keywordtype">bool</span> stencilShadows);
<a name="l00427"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#32defbdc3826482b322f0d5acc9e1b38">00427</a>             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> getID(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRegionID; }
<a name="l00429"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#ae372a915c5f4440504c0928126a0588">00429</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getCentre(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCentre; }
<a name="l00430"></a>00430             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00431"></a>00431             <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00432"></a>00432             <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00433"></a>00433             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00434"></a>00434             <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00435"></a>00435             <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00436"></a>00436             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> getTypeFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00437"></a>00437 
<a name="l00438"></a><a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html#75f120bb28afd724d9c6284d7c8f5a42">00438</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;LODBucketList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">LODIterator</a>;
<a name="l00440"></a>00440             <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">LODIterator</a> getLODIterator(<span class="keywordtype">void</span>);
<a name="l00442"></a>00442             <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">ShadowRenderableListIterator</a> getShadowVolumeRenderableIterator(
<a name="l00443"></a>00443                 <a class="code" href="namespaceOgre.html#79dcd426d291c31072c1ad6f183715d6" title="An enumeration of broad shadow techniques.">ShadowTechnique</a> shadowTechnique, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light, 
<a name="l00444"></a>00444                 <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, 
<a name="l00445"></a>00445                 <span class="keywordtype">bool</span> extrudeVertices, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrusionDistance, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags = 0 );
<a name="l00447"></a>00447             <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* getEdgeList(<span class="keywordtype">void</span>);
<a name="l00449"></a>00449             <span class="keywordtype">bool</span> hasEdgeList(<span class="keywordtype">void</span>);
<a name="l00450"></a>00450 
<a name="l00452"></a>00452             <span class="keywordtype">void</span> dump(std::ofstream&amp; of) <span class="keyword">const</span>;
<a name="l00453"></a>00453             
<a name="l00454"></a>00454         };
<a name="l00462"></a><a class="code" href="classOgre_1_1StaticGeometry.html#f697e3c0524a2e1976e691b38de9b8e1">00462</a>         <span class="keyword">typedef</span> std::map&lt;uint32, Region*&gt; RegionMap;
<a name="l00463"></a>00463     <span class="keyword">protected</span>:
<a name="l00464"></a>00464         <span class="comment">// General state &amp; settings</span>
<a name="l00465"></a><a class="code" href="classOgre_1_1StaticGeometry.html#9b64354296359c4143d3901f144caeee">00465</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* mOwner;
<a name="l00466"></a><a class="code" href="classOgre_1_1StaticGeometry.html#ed8a1cee4285b9c5f68ee6cdb77034e6">00466</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;
<a name="l00467"></a><a class="code" href="classOgre_1_1StaticGeometry.html#12718b6d1611487b71a5ca44681f032a">00467</a>         <span class="keywordtype">bool</span> mBuilt;
<a name="l00468"></a><a class="code" href="classOgre_1_1StaticGeometry.html#b5fb89ef8a654d843afbaee9fdccd754">00468</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mUpperDistance;
<a name="l00469"></a><a class="code" href="classOgre_1_1StaticGeometry.html#d9e3131cdc5b4fdac50094653bf7504e">00469</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mSquaredUpperDistance;
<a name="l00470"></a><a class="code" href="classOgre_1_1StaticGeometry.html#7276450e1765fd0e30ad5dbc5579d3a6">00470</a>         <span class="keywordtype">bool</span> mCastShadows;
<a name="l00471"></a><a class="code" href="classOgre_1_1StaticGeometry.html#32de891715160696eb12e43e284cdf8d">00471</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mRegionDimensions;
<a name="l00472"></a><a class="code" href="classOgre_1_1StaticGeometry.html#d5e0589f7f076bc4115c9ef4e0ccce5f">00472</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mHalfRegionDimensions;
<a name="l00473"></a><a class="code" href="classOgre_1_1StaticGeometry.html#240ae98ece35afb40a62c306bc9ada9c">00473</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mOrigin;
<a name="l00474"></a><a class="code" href="classOgre_1_1StaticGeometry.html#d3af8e218d2d7f78ad9a9f75cde20b2c">00474</a>         <span class="keywordtype">bool</span> mVisible;
<a name="l00476"></a><a class="code" href="classOgre_1_1StaticGeometry.html#30e40527d2a49414f3ea42f5d2c1cec0">00476</a>         <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> mRenderQueueID;
<a name="l00478"></a><a class="code" href="classOgre_1_1StaticGeometry.html#10ed5bde20ec843a68e43d8a7d1d2916">00478</a>         <span class="keywordtype">bool</span> mRenderQueueIDSet;
<a name="l00479"></a>00479 
<a name="l00480"></a><a class="code" href="classOgre_1_1StaticGeometry.html#7e22ae45c63445dc452204313b4a2bf5">00480</a>         QueuedSubMeshList mQueuedSubMeshes;
<a name="l00481"></a>00481 
<a name="l00484"></a><a class="code" href="classOgre_1_1StaticGeometry.html#6c9d832a7c35728a64e9a754a12c4c6f">00484</a>         OptimisedSubMeshGeometryList mOptimisedSubMeshGeometryList;
<a name="l00485"></a>00485 
<a name="l00490"></a><a class="code" href="classOgre_1_1StaticGeometry.html#e65ed08886e5c277250010101472924f">00490</a>         SubMeshGeometryLookup mSubMeshGeometryLookup;
<a name="l00491"></a>00491             
<a name="l00493"></a><a class="code" href="classOgre_1_1StaticGeometry.html#07ce1242365254397cebf8718609fb01">00493</a>         RegionMap mRegionMap;
<a name="l00494"></a>00494 
<a name="l00498"></a>00498         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* getRegion(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bounds, <span class="keywordtype">bool</span> autoCreate);
<a name="l00500"></a>00500         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* getRegion(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; point, <span class="keywordtype">bool</span> autoCreate);
<a name="l00502"></a>00502         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* getRegion(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> z, <span class="keywordtype">bool</span> autoCreate);
<a name="l00504"></a>00504         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for...">Region</a>* getRegion(<a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> index);
<a name="l00507"></a>00507         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRegionIndexes(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; point, 
<a name="l00508"></a>00508             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&amp; x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&amp; y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&amp; z);
<a name="l00511"></a>00511         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> packIndex(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> z);
<a name="l00514"></a>00514         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getVolumeIntersection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box,  
<a name="l00515"></a>00515             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> z);
<a name="l00518"></a>00518         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> getRegionBounds(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> z);
<a name="l00521"></a>00521         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getRegionCentre(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> x, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> y, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> z);
<a name="l00523"></a>00523         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> calculateBounds(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, 
<a name="l00524"></a>00524             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; orientation, 
<a name="l00525"></a>00525             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale);
<a name="l00527"></a>00527         SubMeshLodGeometryLinkList* determineGeometry(<a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* sm);
<a name="l00529"></a>00529         <span class="keywordtype">void</span> splitGeometry(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vd, <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* <span class="keywordtype">id</span>, 
<a name="l00530"></a>00530             <a class="code" href="structOgre_1_1StaticGeometry_1_1SubMeshLodGeometryLink.html" title="Saved link between SubMesh at a LOD and vertex/index data May point to original or...">SubMeshLodGeometryLink</a>* targetGeomLink);
<a name="l00531"></a>00531 
<a name="l00532"></a><a class="code" href="classOgre_1_1StaticGeometry.html#4e1866e85e8c4423fbc9ce36a64d616d">00532</a>         <span class="keyword">typedef</span> std::map&lt;size_t, size_t&gt; IndexRemap;
<a name="l00537"></a>00537         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00538"></a><a class="code" href="classOgre_1_1StaticGeometry.html#dc8fdfc69ff528c77c1157d925212338">00538</a>         <span class="keywordtype">void</span> buildIndexRemap(T* pBuffer, <span class="keywordtype">size_t</span> numIndexes, IndexRemap&amp; remap)
<a name="l00539"></a>00539         {
<a name="l00540"></a>00540             remap.clear();
<a name="l00541"></a>00541             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; numIndexes; ++i)
<a name="l00542"></a>00542             {
<a name="l00543"></a>00543                 <span class="comment">// use insert since duplicates are silently discarded</span>
<a name="l00544"></a>00544                 remap.insert(IndexRemap::value_type(*pBuffer++, remap.size()));
<a name="l00545"></a>00545                 <span class="comment">// this will have mapped oldindex -&gt; new index IF oldindex</span>
<a name="l00546"></a>00546                 <span class="comment">// wasn't already there</span>
<a name="l00547"></a>00547             }
<a name="l00548"></a>00548         }
<a name="l00550"></a>00550         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00551"></a><a class="code" href="classOgre_1_1StaticGeometry.html#62b1551e1142c1464987a9864cf69c92">00551</a>         <span class="keywordtype">void</span> remapIndexes(T* src, T* dst, <span class="keyword">const</span> IndexRemap&amp; remap, 
<a name="l00552"></a>00552                 <span class="keywordtype">size_t</span> numIndexes)
<a name="l00553"></a>00553         {
<a name="l00554"></a>00554             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; numIndexes; ++i)
<a name="l00555"></a>00555             {
<a name="l00556"></a>00556                 <span class="comment">// look up original and map to target</span>
<a name="l00557"></a>00557                 IndexRemap::const_iterator ix = remap.find(*src++);
<a name="l00558"></a>00558                 assert(ix != remap.end());
<a name="l00559"></a>00559                 *dst++ = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(ix-&gt;second);
<a name="l00560"></a>00560             }
<a name="l00561"></a>00561         }
<a name="l00562"></a>00562         
<a name="l00563"></a>00563     <span class="keyword">public</span>:
<a name="l00565"></a>00565         <a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* owner, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00567"></a>00567         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene...">StaticGeometry</a>();
<a name="l00568"></a>00568 
<a name="l00570"></a><a class="code" href="classOgre_1_1StaticGeometry.html#1772aa923f7a9518b57419c46c0cb9c0">00570</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00589"></a>00589         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addEntity(<a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>* ent, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position,
<a name="l00590"></a>00590             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; orientation = <a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>, 
<a name="l00591"></a>00591             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale = <a class="code" href="classOgre_1_1Vector3.html#6a27e8a3a9156701f586afeed1516fb8">Vector3::UNIT_SCALE</a>);
<a name="l00592"></a>00592 
<a name="l00611"></a>00611         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addSceneNode(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* node);
<a name="l00612"></a>00612 
<a name="l00623"></a>00623         <span class="keyword">virtual</span> <span class="keywordtype">void</span> build(<span class="keywordtype">void</span>);
<a name="l00624"></a>00624 
<a name="l00630"></a>00630         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroy(<span class="keywordtype">void</span>);
<a name="l00631"></a>00631 
<a name="l00635"></a>00635         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reset(<span class="keywordtype">void</span>);
<a name="l00636"></a>00636 
<a name="l00646"></a><a class="code" href="classOgre_1_1StaticGeometry.html#275913c7bb86faf4acc86b6bd8e2a9ce">00646</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderingDistance(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dist) { 
<a name="l00647"></a>00647             mUpperDistance = dist; 
<a name="l00648"></a>00648             mSquaredUpperDistance = mUpperDistance * mUpperDistance;
<a name="l00649"></a>00649         }
<a name="l00650"></a>00650 
<a name="l00652"></a><a class="code" href="classOgre_1_1StaticGeometry.html#bc64dfea292342cc15fe7b212ee9e6f5">00652</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getRenderingDistance(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUpperDistance; }
<a name="l00653"></a>00653 
<a name="l00655"></a><a class="code" href="classOgre_1_1StaticGeometry.html#b42fd9a095b26414d11b8a69f46ddfa4">00655</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredRenderingDistance(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00656"></a>00656 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSquaredUpperDistance; }
<a name="l00657"></a>00657 
<a name="l00659"></a>00659         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible);
<a name="l00660"></a>00660 
<a name="l00662"></a><a class="code" href="classOgre_1_1StaticGeometry.html#5cc43e2a7e7292aed18b44a9661e8ba1">00662</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVisible; }
<a name="l00663"></a>00663 
<a name="l00681"></a>00681         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCastShadows(<span class="keywordtype">bool</span> castShadows);
<a name="l00683"></a><a class="code" href="classOgre_1_1StaticGeometry.html#2efcde5992970bde422ac7465107ee62">00683</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getCastShadows(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mCastShadows; }
<a name="l00684"></a>00684 
<a name="l00695"></a><a class="code" href="classOgre_1_1StaticGeometry.html#91b72934294a81bd107747a076fd8a69">00695</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRegionDimensions(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; size) { 
<a name="l00696"></a>00696             mRegionDimensions = size; 
<a name="l00697"></a>00697             mHalfRegionDimensions = size * 0.5;
<a name="l00698"></a>00698         }
<a name="l00700"></a><a class="code" href="classOgre_1_1StaticGeometry.html#305bdacbbce5d91ef9d3dd3df7b4db8c">00700</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getRegionDimensions(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRegionDimensions; }
<a name="l00712"></a><a class="code" href="classOgre_1_1StaticGeometry.html#7e192ed9d7b41ae948b7ca0ed4cb5e0f">00712</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrigin(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; origin) { mOrigin = origin; }
<a name="l00714"></a><a class="code" href="classOgre_1_1StaticGeometry.html#601e05dd3a8f93e39cf6236760d11b6f">00714</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getOrigin(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOrigin; }
<a name="l00715"></a>00715 
<a name="l00727"></a>00727         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueGroup(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueID);
<a name="l00728"></a>00728 
<a name="l00730"></a>00730         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getRenderQueueGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00731"></a>00731         
<a name="l00733"></a><a class="code" href="classOgre_1_1StaticGeometry.html#c58b2faf8a71daf21406ed730215a13a">00733</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;RegionMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">RegionIterator</a>;
<a name="l00735"></a>00735         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">RegionIterator</a> getRegionIterator(<span class="keywordtype">void</span>);
<a name="l00736"></a>00736 
<a name="l00740"></a>00740         <span class="keyword">virtual</span> <span class="keywordtype">void</span> dump(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743     };
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 }
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 <span class="preprocessor">#endif</span>
<a name="l00748"></a>00748 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
